package school_project.Parsers;

import school_project.Map;

import java.io.*;
import java.nio.file.Files;

public class JsonParser implements FileParser{

    @Override
    public void saveLevel(File file, Map levelData, boolean save_data) throws IOException {
        FileOutputStream fileStream = new FileOutputStream(file);
        ObjectOutputStream objectStream = new ObjectOutputStream(fileStream);
        objectStream.writeObject(levelData);

        objectStream.close();
        fileStream.close();
    }

    /**
     * Check if the file is a text file
     * @return true if it is a text File
     */
    public static boolean isJsonFile(File file) throws IOException {
        return Files.probeContentType(file.toPath()).equals("application/json");
    }

    @Override
    public Map getLevel(File file, boolean saved_data) throws IOException {
        FileInputStream fileStream = new FileInputStream(file);
        ObjectInputStream objectStream = new ObjectInputStream(fileStream);
        try {
            return (Map) objectStream.readObject();
        } catch (ClassNotFoundException e) {
            throw new RuntimeException(e);
        }
    }

}
